/* AMX Mod script.
*
* (c) Copyright 2002, dJeyL
* This file is provided as is (no warranties).
*
*/

/*

This AMX plugin requires MySQL MetaSmall module.

For this to work, you might create your MySQL admins table with this SQL query :

  CREATE TABLE admins (
    auth varchar(32) NOT NULL default '',
    password varchar(32) NOT NULL default '',
    access varchar(32) NOT NULL default '',
    flags varchar(32) NOT NULL default ''
  ) TYPE=MyISAM;


Notes :
. check $moddir/addons/amx/mysql.cfg for MySQL access configuration
. you still need admin.amx base plugin
. you still need admin.cfg config file, but can remove admins ("amx_admin" lines)
. admins left there will still be loaded

*/

#include <amxmod>
#include <mysql>

public admin_sql()
{
	new mysql,cnt
	new auth[32]
	new password[32]
	new access[32]
	new flags[32]
	new error[32]
	new host[64]
	new user[32]
	new pass[32]
	new db[32]
	
	get_cvar_string("amx_mysql_host",host,64)
	get_cvar_string("amx_mysql_user",user,32)
	get_cvar_string("amx_mysql_pass",pass,32)
	get_cvar_string("amx_mysql_db",db,32)

	mysql = mysql_connect(host,user,pass,db,error,32)
	if(mysql>0)
	{
		if(mysql_query(mysql,"SELECT auth,password,access,flags FROM admins")>0)
		{
			cnt = 0
			while(mysql_nextrow(mysql)>0)
			{
				mysql_getfield(mysql,1,auth,32)
				mysql_getfield(mysql,2,password,32)
				mysql_getfield(mysql,3,access,32)
				mysql_getfield(mysql,4,flags,32)
				server_cmd("amx_admin ^"%s^" ^"%s^" ^"%s^" ^"%s^"",auth,password,access,flags)
				
				cnt++
			}
			server_print("[AMX] Loaded %d admin(s) from database",cnt)
		}
		else
		{
			mysql_error(mysql,error,32)
			server_print("MySQL error : could not load admins : '%s'",error)
		}
		mysql_close(mysql)
	}
	else
	{
		server_print("MySQL error : could not connect : '%s'",error)
	}
	
	return PLUGIN_HANDLED
}

public plugin_init()
{
	register_plugin("Load admins from SQL","0.6","dJeyL")
	register_srvcmd("amx_sqladmins","admin_sql")
	register_cvar("amx_mysql_host","127.0.0.1")
	register_cvar("amx_mysql_user","root")
	register_cvar("amx_mysql_pass","")
	register_cvar("amx_mysql_db","amx")
	server_cmd("exec addons/amx/mysql.cfg;amx_sqladmins")
	return PLUGIN_CONTINUE
}
